/*=============================================================================
File:	common.h
Purpose:	implements the string_buffer definition

Special thanks to Taku Kudo <taku@chasen.org> for orginal implementation in
http://crfpp.sourceforge.net/

Simplifies only for readability and understandability
   Copyright(C) langine team
   email: nlptech360@gmail.com
   The license is under GNU GPL

Reimplements the operator<< only for compiling on VC6.0
Removes those never used codes in this project
=============================================================================*/

#ifndef CRFPP_COMMON_H_
#define CRFPP_COMMON_H_

namespace CRFPP
{
	class string_buffer: public std::string 
	{
		public:
		string_buffer& operator<<(char _n)//reimplements this operator
		{
			char temp[2];
			temp[0] = _n;
			temp[1] = 0;
			append(temp);
			return *this;
		}
		
		string_buffer& operator<<(const char* _n)
		{
			append(_n);
			return *this;
		}
	};
}

#endif
