/*=============================================================================
File:	crf_test.cpp
Purpose:	does sequence labelling such as word segmentation with crf

Special thanks to Taku Kudo <taku@chasen.org> for orginal implementation in
http://crfpp.sourceforge.net/

Simplifies only for readability and understandability
   Copyright(C) langine team
   email: nlptech360@gmail.com
   The license is under GNU GPL.
=============================================================================*/
  
#include "tagger.h"
int main(int argc, char **argv) 
{
    if(argc < 4)
    {
        printf("using: exe[0], model[1], test file[2], result file[3]\n");
        return 0;
    }

    char szModelPath[256];
    char szTestPath[256];
    char szResultPath[256];

    strcpy(szModelPath,argv[1]);
    strcpy(szTestPath,argv[2]);
    strcpy(szResultPath,argv[3]);

    CRFPP::TaggerImpl tagger;
    if(!tagger.open(szModelPath))
    {
        printf("read the model error\n");
        return 1;
    }

    FILE* fpTest = fopen(szTestPath,"r");
    if(fpTest == NULL)
    {
        printf("Cannot open the test file\n");
        return 1;
    }

    FILE* fpOutput = fopen(szResultPath,"w");
    if(fpOutput == NULL)
    {
        printf("Cannot create the result file\n");
        return 1;
    }

	printf("Begin to process\n");
    bool bSucceeded = true;
    while(!feof(fpTest))
    {
        if(!tagger.ProcessingFile(fpTest,fpOutput))
        {
            bSucceeded = false;
            printf("Processing the file error\n");
            break;
        }
    }
    fclose(fpTest);
    fclose(fpOutput);

    if(bSucceeded)
    {
        printf("Finished Processing successfully\n");
    }

    return 0;
}
