/*=============================================================================
File:	common.h
Purpose:	implements the string_buffer definition

Special thanks to Taku Kudo <taku@chasen.org> for orginal implementation in
http://crfpp.sourceforge.net/

Simplifies only for readability and understandability
   Copyright(C) langine team
   email: nlptech360@gmail.com
   The license is under GNU GPL

Removes those never used codes in this project
=============================================================================*/

#ifndef CRFPP_FEATURE_CACHE_H_
#define CRFPP_FEATURE_CACHE_H_

#include <map>
#include "freelist.h"
using namespace std;

namespace CRFPP {

class FeatureCache: public std::vector <int *> {
	private:
		FreeList<int> feature_freelist_;
		
	public:
		void clear() {
			vector<int *>::clear();
			feature_freelist_.free();
		}
		
		void add(const std::vector<int> &);
		void shrink(std::map<int, int> *);
		
		explicit FeatureCache(): feature_freelist_(8192 * 16) {}
		virtual ~FeatureCache() {}
};
}
#endif
