/*=============================================================================
File:	common.h
Purpose:	implements the string_buffer definition

Special thanks to Taku Kudo <taku@chasen.org> for orginal implementation in
http://crfpp.sourceforge.net/

Simplifies only for readability and understandability
   Copyright(C) langine team
   email: nlptech360@gmail.com
   The license is under GNU GPL

Removes those never used codes in this project
=============================================================================*/

#ifndef CRFPP_PATH_H_
#define CRFPP_PATH_H_

#include <vector>
#include "node.h"

namespace CRFPP {
struct Node;

struct Path {
  Node   *rnode;
  Node   *lnode;
  int    *fvector;
  double  cost;

  Path(): rnode(0), lnode(0), fvector(0), cost(0.0) {}

  void add(Node *_lnode, Node *_rnode)
  {
	  lnode = _lnode;
	  rnode = _rnode;
	  lnode->rpath.push_back(this);
	  rnode->lpath.push_back(this);
  }

  void clear()
  {
    rnode = lnode = 0;
    fvector = 0;
    cost = 0.0;
  }
};

typedef std::vector<Path*>::const_iterator const_Path_iterator;
}
#endif
